#include <uart.h>
#include <avr/io.h>
#define USR UCSRA
#define UCR UCSRB
#define UBRR UBRRL
#define EICR EICRB

#define SYSCLK	8000000	//Quarz Frequenz in Hz
#define BAUD_RATE 38400	//Baud Rate fr die Serielle Schnittstelle	
void uart_init()
{
	UCR=(1 << TXEN);//tx enable...
	UBRR=(SYSCLK / (BAUD_RATE * 16L) - 1);//und bauderate
}
int uart_putchar (char c)
{
	if (c == '\n')
		uart_putchar('\r');
	
		
	loop_until_bit_is_set(USR, UDRE); 
	UDR = c;
	return (0);
}

int uart_print(unsigned char *buffer)
{
	while (*buffer)
	{		
		uart_putchar(*buffer++);
	}
	return (0);
}

int uart_prints(unsigned char *buffer)
{

int x = 512;
	while (x--)
	{		
		uart_putchar(*buffer++);
	}
	return (0);
}
